import axios from 'axios';
import { Errors } from './ErrorMessages';

type methods = 'GET' | 'POST' | 'UPDATE' | 'DELETE'

export async function request<R,D>(method:methods,url?:string,data?:D):Promise<R>{
    if(!url){
        throw({message:'Empty login url'})
    }else{
        switch(method){
            case "GET":
                return await get(url)
            case "UPDATE":
                break;
            case "POST":
                break;
            case "DELETE":
                break;
        }
    }
}
async function get<R>(url:string):Promise<R>{
    try{
        const respons = await axios.get<R,R>(url)
        return respons
    } catch(error){
        let errorMsg = ''
        if(!error.response){
            errorMsg = Errors.noInternet
        } else{
            if(!error.response.data.message){
                errorMsg = Errors.serverError
            } else{
                errorMsg =  error.response.data.message;
            }
        }
        throw new Error(errorMsg)
    }
}

